Package com.documentum.fc.client.search

# Class DfExpressionVisitor

java.lang.Object
com.documentum.fc.client.search.DfExpressionVisitor

public abstract class DfExpressionVisitor extends Object
Abstract visitor used to visit an IDfExpression.

The Visitor pattern allows to visit an expression node or an expression tree, with no need to cast the different kinds of expression.

See Also:
  - `IDfExpression.acceptVisitor(DfExpressionVisitor)`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DfExpressionVisitor()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(IDfExpressionSet expr)`
  Visits an `IDfExpressionSet`.
  `void`
  `visit(IDfFullTextExpression expr)`
  Visits an `IDfFullTextExpression`.
  `void`
  `visit(IDfRelativeDateExpression expr)`
  Visits an `IDfRelativeDateExpression`.
  `void`
  `visit(IDfSimpleAttrExpression expr)`
  Visits an `IDfSimpleAttrExpression`.
  `void`
  `visit(IDfValueListAttrExpression expr)`
  Visits an `IDfValueListAttrExpression`.
  `void`
  `visit(IDfValueRangeAttrExpression expr)`
  Visits an `IDfValueRangeAttrExpression`.
  `protected void`
  `visitDefault(IDfExpression expr)`
  Default method called if the sub-class does not override a visit method.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DfExpressionVisitor

    public DfExpressionVisitor()

- ## Method Details

  - ### visit

    public void visit(IDfExpressionSet expr) throws DfException
    Visits an `IDfExpressionSet`.

    This class default implementation iterates over its children and recursively visits the sub-expressions. If the implementer doesn't call super, he can implement his own iterating mechanism.

    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor (by default, no such exception is thrown).
      `DfException`

  - ### visit

    public void visit(IDfValueListAttrExpression expr) throws DfException
    Visits an `IDfValueListAttrExpression`.
    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`

  - ### visit

    public void visit(IDfFullTextExpression expr) throws DfException
    Visits an `IDfFullTextExpression`.
    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`

  - ### visit

    public void visit(IDfSimpleAttrExpression expr) throws DfException
    Visits an `IDfSimpleAttrExpression`.
    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`

  - ### visit

    public void visit(IDfRelativeDateExpression expr) throws DfException
    Visits an `IDfRelativeDateExpression`.
    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`

  - ### visit

    public void visit(IDfValueRangeAttrExpression expr) throws DfException
    Visits an `IDfValueRangeAttrExpression`.
    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`

  - ### visitDefault

    protected void visitDefault(IDfExpression expr) throws DfException
    Default method called if the sub-class does not override a visit method.

    Implement this method if you want to catch any kind of expression that was not initially taken into account.

    Parameters:
      `expr` - The expression visited.
    Throws:
      `DfSearchException` - The exception thrown by the visitor.
      `DfException`